' ----- The Library Project
'       Start-to-Finish Visual Basic 2005
'       Copyright (c) 2006 by Tim Patrick

Public Class SubjectAdd
    Private ActiveID As Integer

    Public Function AddRecord() As Integer
        ' ----- Add a new subject.
        ActiveID = -1
        Me.ShowDialog()
        If (Me.DialogResult = Windows.Forms.DialogResult.OK) Then _
            Return ActiveID Else Return -1
    End Function

    Private Function SaveFormData() As Boolean
        ' ----- Save the record to the database.
        Dim sqlText As String
        Dim newID As Integer
        Dim dbInfo As SqlClient.SqlDataReader

        On Error GoTo ErrorHandler
        Me.Cursor = Windows.Forms.Cursors.WaitCursor

        ' ----- See if this subject already exists.
        sqlText = "SELECT ID FROM Subject WHERE FullName LIKE " & _
            DBText(Trim(RecordSubject.Text))
        dbInfo = CreateReader(sqlText)
        If (dbInfo.Read()) Then ActiveID = CInt(dbInfo!ID)
        dbInfo.Close()
        dbInfo = Nothing

        ' ----- Create a new record if needed.
        If (ActiveID = -1) Then
            ' ----- Create a new entry.
            sqlText = "INSERT INTO Subject (FullName) OUTPUT INSERTED.ID VALUES (" & _
                DBText(Trim(RecordSubject.Text)) & ")"
            newID = CInt(ExecuteSQLReturn(sqlText))
            ActiveID = newID
        End If

        ' ----- Success.
        Me.Cursor = Windows.Forms.Cursors.Default
        Return True

ErrorHandler:
        Me.Cursor = Windows.Forms.Cursors.Default
        GeneralError("SubjectAdd.SaveFormData", Err.GetException())
        On Error Resume Next
        If Not (dbInfo Is Nothing) Then dbInfo.Close() : dbInfo = Nothing
        Return False
    End Function

    Private Function ValidateFormData() As Boolean
        ' ----- Subject is a required field.
        If (Trim(RecordSubject.Text) = "") Then
            MsgBox("Please supply a subject.", _
                MsgBoxStyle.OkOnly Or MsgBoxStyle.Exclamation, ProgramTitle)
            RecordSubject.Focus()
            Return False
        End If

        ' ----- Success.
        Return True
    End Function

    Private Sub RecordSubject_GotFocus(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RecordSubject.GotFocus
        ' ----- Highlight the entire text.
        RecordSubject.SelectAll()
    End Sub

    Private Sub ActOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ActOK.Click
        ' ----- The user wants to save changes.
        If (ValidateFormData() = False) Then Return
        If (SaveFormData() = False) Then Return

        ' ----- Continue with AddRecord() 
        Me.DialogResult = Windows.Forms.DialogResult.OK
    End Sub
End Class
