' ----- The Library Project
'       Start-to-Finish Visual Basic 2005
'       Copyright (c) 2006 by Tim Patrick

Public Class ChangeUser
    Private Sub AdjustOption()
        ' ----- Adjust the option setting based on the user entry.
        OptionPatron.Checked = CBool(Trim(LoginID.Text) = "")
        OptionAdmin.Checked = Not OptionPatron.Checked
    End Sub

    Private Sub LoginID_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles LoginID.Enter
        ' ----- Highlight the entire text.
        LoginID.SelectAll()
    End Sub

    Private Sub Password_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Password.Enter
        ' ----- Highlight the entire text.
        Password.SelectAll()
    End Sub

    Private Sub LoginID_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles LoginID.TextChanged
        ' ----- Refresh the option.
        AdjustOption()
    End Sub

    Private Sub Password_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Password.TextChanged
        ' ----- Refresh the option.
        AdjustOption()
    End Sub

    Private Sub ActOK_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ActOK.Click
        ' ----- Accept the user's input.
        Dim sqlText As String
        Dim dbInfo As SqlClient.SqlDataReader
        Dim comparePassword As String

        On Error GoTo ErrorHandler

        ' ----- Different code for patron or user mode.
        If (OptionPatron.Checked = True) Then
            ' ----- Patron mode is easy.
            LoggedInUserID = -1
            LoggedInUserName = ""
            LoggedInGroupID = -1
            ReprocessSecuritySet()
            Me.DialogResult = Windows.Forms.DialogResult.OK
            Return
        End If

        ' ----- Check for a valid entry.
        If (Trim(LoginID.Text) = "") Then
            MsgBox("To connect as an administrative user, you must provide a valid " & _
                "login ID.", MsgBoxStyle.OkOnly Or MsgBoxStyle.Exclamation, ProgramTitle)
            Return
        End If

        ' ----- Check the user name and password.
        sqlText = "SELECT * FROM UserName WHERE UPPER(LoginID) = " & _
            DBText(UCase(Trim(LoginID.Text)))
        dbInfo = CreateReader(sqlText)
        If (dbInfo.Read = False) Then
            MsgBox("Invalid login ID or password.", MsgBoxStyle.OkOnly Or _
                MsgBoxStyle.Exclamation, ProgramTitle)
            dbInfo.Close()
            dbInfo = Nothing
            Return
        End If

        ' ----- Check for an inactive user.
        If (CBool(dbInfo!Active) = False) Then
            MsgBox("The administrator has disabled your account.", _
                MsgBoxStyle.OkOnly Or MsgBoxStyle.Exclamation, ProgramTitle)
            dbInfo.Close()
            dbInfo = Nothing
            Return
        End If

        ' ----- Check the password.
        If (IsDBNull(dbInfo!Password)) Then
            comparePassword = EncryptPassword(Trim(LoginID.Text), "")
        Else
            comparePassword = CStr(dbInfo!Password)
        End If
        If (EncryptPassword(Trim(LoginID.Text), Trim(Password.Text)) <> _
                comparePassword) Then
            MsgBox("Invalid login ID or password.", MsgBoxStyle.OkOnly Or _
                MsgBoxStyle.Exclamation, ProgramTitle)
            dbInfo.Close()
            dbInfo = Nothing
            Return
        End If

        ' ----- Successful login.
        LoggedInUserID = CInt(dbInfo!ID)
        LoggedInUserName = CStr(dbInfo!LoginID)
        LoggedInGroupID = CInt(dbInfo!GroupID)
        dbInfo.Close()
        dbInfo = Nothing
        ReprocessSecuritySet()
        Me.DialogResult = Windows.Forms.DialogResult.OK
        Return

ErrorHandler:
        GeneralError("ChangeUser.ActOK_Click", Err.GetException())
        On Error Resume Next
        If Not (dbInfo Is Nothing) Then dbInfo.Close() : dbInfo = Nothing
        Return
    End Sub
End Class
