' ----- The Library Project
'       Start-to-Finish Visual Basic 2005
'       Copyright (c) 2006 by Tim Patrick

Public Class ItemAuthorEdit
    Private ItemID As Integer
    Private AuthorID As Integer
    Private OrigTypeID As Integer

    Public Function EditRecord(ByVal useItemID As Integer, ByVal useAuthorID As Integer, _
            ByVal useItemName As String, ByVal useAuthorName As String, _
            ByVal useOrigNameType As Integer) As Integer
        ' ----- Edit the name type of an existing item/author relationship.
        '       If the user changes the name type, return the name type ID.
        '       Otherwise, return -1.
        ItemID = useItemID
        AuthorID = useAuthorID
        OrigTypeID = useOrigNameType
        ItemName.Text = useItemName
        AuthorName.Text = useAuthorName
        Me.ShowDialog()
        If (Me.DialogResult = Windows.Forms.DialogResult.OK) Then _
            Return CInt(CType(NameType.SelectedItem, ListItemData)) Else Return -1
    End Function

    Private Function SaveFormData() As Boolean
        ' ----- Save changes to the database.
        Dim sqlText As String

        On Error GoTo ErrorHandler
        Me.Cursor = Windows.Forms.Cursors.WaitCursor

        ' ----- Update the record in the database.
        sqlText = "UPDATE ItemAuthor SET " & _
            "AuthorType = " & DBCombo(NameType) & _
            " WHERE ItemID = " & ItemID & " AND AuthorID = " & AuthorID
        ExecuteSQL(sqlText)

        ' ----- Success.
        Me.Cursor = Windows.Forms.Cursors.Default
        Return True

ErrorHandler:
        Me.Cursor = Windows.Forms.Cursors.Default
        GeneralError("ItemAuthorEdit.SaveFormData", Err.GetException())
        Return False
    End Function

    Private Function ValidateFormData() As Boolean
        ' ----- The name type must be selected.
        If (CInt(CType(NameType.SelectedItem, ListItemData)) = -1) Then
            MsgBox("Please select a name type.", _
                MsgBoxStyle.OkOnly Or MsgBoxStyle.Exclamation, ProgramTitle)
            NameType.Focus()
            Return False
        End If

        ' ----- Success.
        Return True
    End Function

    Private Sub ActOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ActOK.Click
        ' ----- The user wants to save changes.
        If (ValidateFormData() = False) Then Return
        If (SaveFormData() = False) Then Return
        Me.DialogResult = Windows.Forms.DialogResult.OK
    End Sub

    Private Sub ItemAuthorEdit_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' ----- Prepare the form.
        Dim sqlText As String
        Dim dbInfo As SqlClient.SqlDataReader

        On Error GoTo ErrorHandler

        ' ----- Load in the list of name types.
        NameType.Items.Add(New ListItemData("<Select a Name Type>", -1))
        NameType.SelectedIndex = 0
        sqlText = "SELECT * FROM CodeAuthorType ORDER BY FullName"
        dbInfo = CreateReader(sqlText)
        Do While dbInfo.Read
            NameType.Items.Add(New ListItemData(CStr(dbInfo!FullName), CInt(dbInfo!ID)))
        Loop
        dbInfo.Close()
        dbInfo = Nothing

        ' ----- Set the existing name type.
        NameType.SelectedIndex = NameType.Items.IndexOf(OrigTypeID)
        If (NameType.SelectedIndex = -1) Then _
            NameType.SelectedIndex = NameType.Items.IndexOf(-1)
        Return

ErrorHandler:
        GeneralError("ItemAuthorEdit.ItemAuthorEdit_Load", Err.GetException())
        On Error Resume Next
        If Not (dbInfo Is Nothing) Then dbInfo.Close() : dbInfo = Nothing
        Return
    End Sub
End Class
