' ----- The Library Project
'       Start-to-Finish Visual Basic 2005
'       Copyright (c) 2006 by Tim Patrick

Public Enum ReportItemEnum
    ' ----- The type of item in the report select list.
    GroupLabel = 0
    BuiltInCheckedOut = 1
    BuiltInOverdue = 2
    BuiltInMissing = 3
    BuiltInFinesOwed = 4
    BuiltInStatistics = 5
    ExeProgram = 6
    UrlProgram = 7
End Enum

Public Class ReportItem
    ' ----- Instance of report selection items used
    '       in the ReportSelect form.
    Public ItemType As ReportItemEnum
    Public Indent As Integer     ' Indent level. Starts with 0.
    Public DisplayText As String
    Public ReportPath As String  ' ExeProgram / UrlProgram only
    Public ReportArgs As String  ' ExeProgram only
    Public Description As String

    Public Overrides Function ToString() As String
        ' ----- Display an indented string. Prepend with spaces.
        Return StrDup(Indent * 5, " ") & DisplayText
    End Function
End Class
