' ----- The Library Project
'       Start-to-Finish Visual Basic 2005
'       Copyright (c) 2006 by Tim Patrick

Public Class HolidaySet
    Private HolidayType As String
    Private HolidayDetail As String
    Private IsValid As Boolean

    Public Sub New(ByVal entryType As String, ByVal entryDetail As String)
        ' ----- Create a new holiday entry instance.
        HolidayType = Left(Trim(UCase(entryType)), 1)
        HolidayDetail = entryDetail

        ' ----- See if the details are valid.
        IsValid = True
        Select Case HolidayType
            Case "A"
                ' ----- The detail should be in mm/dd format.
                IsValid = IsDate(entryDetail & "/2004")
            Case "E"
                ' ----- The detail is a number from 1 to 7.
                If (Val(entryDetail) < 1) Or (Val(entryDetail) > 7) Then IsValid = False
            Case "O"
                ' ----- The detail should be a valid date.
                IsValid = IsDate(entryDetail)
            Case Else
                ' ---- Invalid. This should never happen.
                IsValid = False
        End Select
    End Sub

    Public Function IsHoliday(ByVal whatDate As Date) As Boolean
        ' ----- Given a date, see if it matches the entry type in this instance.
        Dim buildDate As String

        ' ----- If this record is invalid, then it is never a holiday match.
        If (IsValid = False) Then Return False

        Select Case HolidayType
            Case "A"
                ' ----- Annual.
                buildDate = HolidayDetail & "/" & Year(whatDate)
                If (IsDate(buildDate)) Then
                    Return CBool(CDate(buildDate) = whatDate)
                Else
                    ' ----- Must be 2/29 on a non-leap-year.
                    Return False
                End If
            Case "E"
                ' ----- Day of the week.
                Return CBool(Val(HolidayDetail) = Weekday(whatDate, FirstDayOfWeek.Sunday))
            Case "O"
                ' ----- See if this is an exact one-time match.
                Return CBool(CDate(HolidayDetail) = whatDate)
        End Select
    End Function
End Class
