' ----- The Library Project
'       Start-to-Finish Visual Basic 2005
'       Copyright (c) 2006 by Tim Patrick

Public Class LocateLicense
    Private LocationModified As Boolean = False

    Public Function ChangeLicense() As Boolean
        Me.ShowDialog()
        Return LocationModified
    End Function

    Private Sub DisplayLicenseStatus()
        ' ----- Show the current status of the license.
        Dim licenseDetails As LicenseFileDetail

        ' ----- Get the license details.
        LicenseStatusColor.BackColor = Color.Red
        licenseDetails = ExamineLicense()
        Select Case licenseDetails.Status
            Case LicenseStatus.ValidLicense
                LicenseStatusColor.BackColor = Color.Green
                LicenseStatusText.Text = "The license is valid."
            Case LicenseStatus.MissingLicenseFile
                LicenseStatusText.Text = _
                    "The license file could not be found."
            Case LicenseStatus.CorruptLicenseFile
                LicenseStatusText.Text = _
                    "The license file was corrupt or contained invalid data."
            Case LicenseStatus.InvalidSignature
                LicenseStatusText.Text = _
                    "The license file's contents did not match its digital signature."
            Case LicenseStatus.NotYetLicensed
                LicenseStatusText.Text = _
                    "Although the license file is valid, it cannot be used until " & _
                    Format(licenseDetails.LicenseDate, "Long Date") & "."
            Case LicenseStatus.LicenseExpired
                LicenseStatusText.Text = _
                    "Although the license file is valid, it expired on " & _
                    Format(licenseDetails.ExpireDate, "Long Date") & "."
            Case LicenseStatus.VersionMismatch
                LicenseStatusText.Text = _
                    "The application version of " & _
                    My.Application.Info.Version.ToString() & _
                    " does not match the licensed version of " & _
                    licenseDetails.CoveredVersion & "."
        End Select
    End Sub

    Private Sub ActLocate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ActLocate.Click
        ' ----- Prompt the user for a new license file.
        If (LocateLicenseDialog.ShowDialog() <> _
                Windows.Forms.DialogResult.OK) Then Return

        ' ----- Store the new path.
        My.Settings.LicenseFileLocation = LocateLicenseDialog.FileName
        LocationModified = True

        ' ----- Update the display.
        DisplayLicenseStatus()
        LicensePath.Text = My.Settings.LicenseFileLocation
    End Sub

    Private Sub LocateLicense_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        ' ----- F1 shows online help.
        If (e.KeyCode = Keys.F1) Then OnlineHelp(Me, "LocateLicense.htm")
    End Sub

    Private Sub LocateLicense_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' ----- Display the current status.
        DisplayLicenseStatus()

        ' ----- Also display the license location.
        LicensePath.Text = My.Settings.LicenseFileLocation
    End Sub
End Class