' ----- The Library Project
'       Start-to-Finish Visual Basic 2005
'       Copyright (c) 2006 by Tim Patrick

Public Class PatronPassword
    Private ActiveID As Integer

    Public Function ChangePassword(ByVal patronID As Integer) As Boolean
        ' ----- Edit an existing record.
        ActiveID = patronID
        Me.ShowDialog()
        If (Me.DialogResult = Windows.Forms.DialogResult.OK) Then _
            Return True Else Return False
    End Function

    Private Function SaveFormData() As Boolean
        ' ----- The user wants to save changes.
        Dim sqlText As String

        On Error GoTo ErrorHandler
        Me.Cursor = Windows.Forms.Cursors.WaitCursor

        ' ----- Save the data.
        sqlText = "UPDATE Patron SET [Password] = " & _
            DBText(EncryptPassword("patron", Trim(RecordPassword.Text))) & _
            " WHERE ID = " & ActiveID
        ExecuteSQL(sqlText)

        ' ----- Success.
        Me.Cursor = Windows.Forms.Cursors.Default
        Return True

ErrorHandler:
        Me.Cursor = Windows.Forms.Cursors.Default
        GeneralError("PatronPassword.SaveFormData", Err.GetException())
        Return False
    End Function

    Private Function ValidateFormData() As Boolean
        ' ----- Make sure the user supplied valid data. Return True on success.
        On Error GoTo ErrorHandler

        ' ----- Password and confirm must match.
        If (RecordPassword.Text <> RecordConfirm.Text) Then
            MsgBox("The Password and Confirm fields must match.", _
                MsgBoxStyle.OkOnly Or MsgBoxStyle.Exclamation, ProgramTitle)
            RecordPassword.Focus()
            Return False
        End If

        ' ----- A password is required.
        If (Trim(RecordPassword.Text) = "") Then
            MsgBox("The Password field is required.", MsgBoxStyle.OkOnly Or _
                MsgBoxStyle.Exclamation, ProgramTitle)
            RecordPassword.Focus()
            Return False
        End If

        ' ----- Success.
        Return True

ErrorHandler:
        GeneralError("PatronPassword.ValidateFormData", Err.GetException())
        Return False
    End Function

    Private Sub ActOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ActOK.Click
        ' ----- The user wants to save changes.
        If (ValidateFormData() = False) Then Return
        If (SaveFormData() = False) Then Return
        Me.DialogResult = Windows.Forms.DialogResult.OK
    End Sub

    Private Sub RecordPassword_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles RecordPassword.Enter
        ' ----- Highlight the entire text.
        RecordPassword.Focus()
    End Sub

    Private Sub RecordConfirm_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles RecordConfirm.Enter
        ' ----- Highlight the entire text.
        RecordConfirm.Focus()
    End Sub

    Private Sub PatronPassword_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        ' ----- F1 shows online help.
        If (e.KeyCode = Keys.F1) Then OnlineHelp(Me, "PatronPassword.htm")
    End Sub

    Private Sub PatronPassword_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' ----- Prepare the form.
        Dim sqlText As String

        On Error GoTo ErrorHandler

        ' ----- Show the patron name.
        sqlText = "SELECT FirstName + ' ' + LastName FROM Patron WHERE ID = " & _
            ActiveID
        RecordName.Text = CStr(ExecuteSQLReturn(sqlText))
        RecordPassword.Clear()
        RecordConfirm.Clear()
        Return

ErrorHandler:
        GeneralError("PatronPassword.Form_Load", Err.GetException())
        Resume Next
    End Sub
End Class