Public Class Form1
    Private WhichPage As Integer

    Private Sub ActPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ActPrint.Click
        ' ----- Prompt the user for printer settings, and start printing.
        UserPrinter.Document = CountingDoc

        UserPrinter.AllowSomePages = True
        CountingDoc.PrinterSettings.MinimumPage = 1
        CountingDoc.PrinterSettings.MaximumPage = 5
        CountingDoc.PrinterSettings.FromPage = 1
        CountingDoc.PrinterSettings.ToPage = 5

        If (UserPrinter.ShowDialog() = Windows.Forms.DialogResult.OK) Then _
            CountingDoc.Print()
    End Sub

    Private Sub CountingDoc_BeginPrint(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintEventArgs) Handles CountingDoc.BeginPrint
        ' ----- Start the counting over.
        WhichPage = CountingDoc.PrinterSettings.FromPage
    End Sub

    Private Sub CountingDoc_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles CountingDoc.PrintPage
        ' ----- Print a single page.
        Dim hugeFont As Font
        Dim centeredText As StringFormat

        ' ----- Let's go overboard on the font: 256 points!
        hugeFont = New Font("Arial", 256)

        ' ----- Center the text on the page.
        centeredText = New StringFormat()
        centeredText.Alignment = StringAlignment.Center
        centeredText.LineAlignment = StringAlignment.Center

        ' ----- Print the number.
        e.Graphics.DrawString(CStr(WhichPage), hugeFont, Brushes.Black, _
            e.MarginBounds, centeredText)

        ' ----- Draw the page margins to make it clear where they are.
        e.Graphics.DrawRectangle(Pens.Blue, e.MarginBounds)

        ' ----- Limit the output to five pages.
        WhichPage += 1
        If (WhichPage <= CountingDoc.PrinterSettings.FromPage) _
            Then e.HasMorePages = True Else e.HasMorePages = False
    End Sub

    Private Sub ActPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ActPreview.Click
        ' ----- Display a preview of the document.
        UserPreview.Document = CountingDoc
        CountingDoc.PrinterSettings.PrintRange = Printing.PrintRange.AllPages
        UserPreview.ShowDialog()
    End Sub
End Class
